SystemOrganization addCategory: #GODSocialNetIOTests!

TestCase subclass: #SNETFacebookFetcherTest
	instanceVariableNames: 'fetcher'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GODSocialNetIOTests'!

!SNETFacebookFetcherTest commentStamp: 'TA 11/26/2014 22:48' prior: 0!
A SNETFacebookFetcherTest is a class that contains all the tests needed for the class SNETFacebookFetcher and It's data containers.!

!SNETFacebookFetcherTest methodsFor: 'initialize-release' stamp: 'T.A. 10/31/2014 16:49'!
setUp
	fetcher := SNETFacebookFetcher new.
	fetcher connect.! !

!SNETFacebookFetcherTest methodsFor: 'tests' stamp: 'EBA 11/3/2014 20:58'!
testConnect
	"Tests Facebook fetcher connection with the API."
	|result| 

	fetcher connect.
	
	result := fetcher  instVarNamed: 'accessToken'.

	self assert: (result includesSubString: 'access_token').
	
	self assert: (result isEmpty not).! !

!SNETFacebookFetcherTest methodsFor: 'tests' stamp: 'EBA 11/14/2014 23:50'!
testEvents
	"Tests the search for events."
	|result item|

	result := fetcher events: 'party'.

	self assert: (result notNil).

	self assert: (result size) > 0.

	item := result event: 1.

	self assert: (item isMemberOf: SNETFacebookEvent).

	self assert: (item name isEmpty not).

	! !

!SNETFacebookFetcherTest methodsFor: 'tests' stamp: 'EBA 11/14/2014 23:51'!
testEventsSince
	"Tests the search for events with filters."
	|result item|

	result := fetcher events: 'party' since: '2014-01-01' asDate.

	self assert: (result notNil).

	self assert: (result size) > 0.

	item := result event: 1.

	self assert: (item isMemberOf: SNETFacebookEvent).

	self assert: (item name isEmpty not).! !

!SNETFacebookFetcherTest methodsFor: 'tests' stamp: 'EBA 11/14/2014 23:51'!
testEventsSinceUntil
	"Tests the search for events with filters."
	|result item|

	result := fetcher events: 'party' since: '2014-01-01' asDate until: '2015-01-01' asDate.

	self assert: (result notNil).

	self assert: (result size) > 0.

	item := result event: 1.

	self assert: (item isMemberOf: SNETFacebookEvent).

	self assert: (item name isEmpty not).

	self assert: (item location isEmpty not).! !

!SNETFacebookFetcherTest methodsFor: 'tests' stamp: 'EBA 11/14/2014 23:53'!
testGroupDescription
	"Tests group description search."
	|result|

	result := fetcher groupDescription: '161572000688140'.

	self assert: (result notNil).

	self assert: (result isMemberOf: SNETFacebookGroupDescriptionData).
	
	self assert: (result description isEmpty not).! !

!SNETFacebookFetcherTest methodsFor: 'tests' stamp: 'EBA 11/14/2014 23:53'!
testGroups
	"Tests group search."
	|result item|

	result := fetcher groups: 'party'.

	self assert: (result size) > 0.

	item := result group: 1.

	self assert: (item isMemberOf: SNETFacebookGroup).

	self assert: (item name isEmpty not).

	! !

!SNETFacebookFetcherTest methodsFor: 'tests' stamp: 'EBA 11/14/2014 23:53'!
testPageDescription
	"Tests page description search."
	|result|

	result := fetcher pageDescription: '152871911535347'.

	self assert: (result notNil).

	self assert: (result isMemberOf: SNETFacebookPageDescriptionData).
	
	self assert: (result description isEmpty not).! !

!SNETFacebookFetcherTest methodsFor: 'tests' stamp: 'EBA 11/14/2014 23:53'!
testPages
	"Tests page search."
	|result item|

	result := fetcher pages: 'Santo Closet'.

	self assert: (result size) > 0.

	item := result page: 1.

	self assert: (item isMemberOf: SNETFacebookPage).

	self assert: (item name isEmpty not).! !

!SNETFacebookFetcherTest methodsFor: 'tests' stamp: 'EBA 11/14/2014 23:54'!
testPosts
	"Tests a simple Facebook user posts search."
	|result item|

	result := fetcher posts: 'nike'.

	self assert: (result size) > 0.

	item := result post: 1.

	self assert: (item isMemberOf: SNETFacebookPost).

	self assert: (item message isEmpty not).! !

!SNETFacebookFetcherTest methodsFor: 'tests' stamp: 'EBA 11/14/2014 23:56'!
testPostsSince
	"Tests a simple Facebook user posts search filtered by date."
	|result item|

	result := fetcher posts: 'nike' since: '2014-01-01' asDate.

	self assert: (result size) > 0.

	item := result post: 1.

	self assert: (item isMemberOf: SNETFacebookPost).

	self assert: (item message isEmpty not).! !

!SNETFacebookFetcherTest methodsFor: 'tests' stamp: 'EBA 11/14/2014 23:56'!
testPostsSinceUntil
	"Tests a simple Facebook user posts search filtered by date."
	|result item|

	result := fetcher posts: 'nike' since: '2014-01-01' asDate until: '2014-10-01' asDate.

	self assert: (result size) > 0.

	item := result post: 1.

	self assert: (item isMemberOf: SNETFacebookPost).

	self assert: (item message isEmpty not).! !

!SNETFacebookFetcherTest methodsFor: 'tests' stamp: 'TA 11/27/2014 00:13'!
testSendRequest
	"Test send request method."
	|result|

	result := fetcher sendRequest: 'https://google.com'.
	
	self assert: (result isEmpty not).! !

!SNETFacebookFetcherTest methodsFor: 'tests' stamp: 'EBA 11/14/2014 23:56'!
testUsers
	"Tests a simple Facebook user search. The user search seems to be broken on Graph API v2.1."
	|result|

	result := fetcher users: 'Eduardo Barreto Alexandre'.

	self assert: (result notNil).

	"User search is bugged on facebook!!"

	"item := result post: 1.

	self assert: (item isMemberOf: SNETFacebookUsersData).

	self assert: (item message size) > 0."! !

!SNETFacebookFetcherTest methodsFor: 'tests' stamp: 'EBA 11/14/2014 23:52'!
testbyId
	"Tests an APP search by id."
	|result|

	result := fetcher byId: '743980072335668'.

	self assert: (result size) > 0.! !

TestCase subclass: #SNETTwitterFetcherTest
	instanceVariableNames: 'fetcher'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GODSocialNetIOTests'!

!SNETTwitterFetcherTest commentStamp: 'TA 11/26/2014 22:47' prior: 0!
A SNETTwitterFetcherTest is a class that contains all the tests needed for the class SNETTwitterFetcher and It's data containers.!

!SNETTwitterFetcherTest methodsFor: 'initialize-release' stamp: 'T.A. 10/31/2014 16:48'!
setUp
	fetcher := SNETTwitterFetcher new.
	fetcher connect.! !

!SNETTwitterFetcherTest methodsFor: 'tests' stamp: 'EBA 11/3/2014 20:56'!
testConnect
	"Tests Twitter fetcher connection with the API."
	|result| 

	fetcher connect.
	
	result := fetcher  instVarNamed: 'accessToken'.
	
	self assert: (result isEmpty not).! !

!SNETTwitterFetcherTest methodsFor: 'tests' stamp: 'EBA 11/14/2014 23:57'!
testPosts
	"Tests a simple Twitter user posts search."
	|result item|

	result := fetcher posts: '@usponline'.

	self assert: (result size) > 0.

	item := result tweet: 1.

	self assert: (item isMemberOf: SNETTwitterTweet).

	self assert: (item message isEmpty not).
	
	self assert: (item retweets) >= 0.
	
	self assert: (item favorited) >= 0.
	! !

!SNETTwitterFetcherTest methodsFor: 'tests' stamp: 'EBA 11/14/2014 23:58'!
testPostsMaximum
	"Tests a simple Twitter user posts search with a maximum number of results."
	|result item|

	result := fetcher posts: '@usponline' maximum: 20.

	self assert: (result size) = 20.

	item := result tweet: 1.

	self assert: (item isMemberOf: SNETTwitterTweet).

	self assert: (item message isEmpty not).
	
	self assert: (item retweets) >= 0.
	
	self assert: (item favorited) >= 0.! !

!SNETTwitterFetcherTest methodsFor: 'tests' stamp: 'TA 11/27/2014 00:13'!
testSendRequest
	"Test send request method."
	|result|

	result := fetcher sendRequest: 'https://google.com'.
	
	self assert: (result isEmpty not).! !

!SNETTwitterFetcherTest methodsFor: 'tests' stamp: 'TA 11/27/2014 00:08'!
testSendRequestMethodGet
	"Test send request method with post and get."
	|result|

	result := fetcher sendRequest: 'https://google.com' method: 'GET'.
	
	self assert: (result isEmpty not).! !

!SNETTwitterFetcherTest methodsFor: 'tests' stamp: 'TA 11/27/2014 00:08'!
testSendRequestMethodPost
	"Test send request method with post and get."
	|result|

	result := fetcher sendRequest: 'https://google.com' method: 'POST'.

	self assert: (result isEmpty not).! !

!SNETTwitterFetcherTest methodsFor: 'tests' stamp: 'EBA 11/14/2014 23:59'!
testTweets
	"Tests search tweets by message text."
	|result item|

	result := fetcher tweets: 'usp convida'.

	self assert: (result size) > 0.

	item := result tweet: 1.

	self assert: (item isMemberOf: SNETTwitterTweet).

	self assert: (item message isEmpty not).! !

!SNETTwitterFetcherTest methodsFor: 'tests' stamp: 'EBA 11/14/2014 23:59'!
testTweetsByAllOfTheseWords
	"Test search tweets that contain all of these words."
	|result item|

	result := fetcher tweets: '#GODSocialNetIO Teste Unitrio. Ignorar'.

	self assert: (result size) > 0.

	item := result tweet: 1.

	self assert: (item isMemberOf: SNETTwitterTweet).

	self assert: (item message isEmpty not).! !

!SNETTwitterFetcherTest methodsFor: 'tests' stamp: 'EBA 11/14/2014 23:59'!
testTweetsByAllTheseHashtags
	"Test search tweets that contain all these hashtags "
	|result item|

	result := fetcher tweets: '#GODSocialNetIO #TestSocialNetIO'.

	self assert: (result size) > 0.

	item := result tweet: 1.

	self assert: (item isMemberOf: SNETTwitterTweet).

	self assert: (item message isEmpty not).! !

!SNETTwitterFetcherTest methodsFor: 'tests' stamp: 'EBA 11/15/2014 00:04'!
testTweetsByAnyOfTheseWords
	"Test search tweets that contain any of these words."
	|result item|

	result := fetcher tweets: '#GODSocialNetIO OR Teste OR Unitrio OR Ignorar'.

	self assert: (result size) > 0.

	item := result tweet: 1.

	self assert: (item isMemberOf: SNETTwitterTweet).

	self assert: (item message isEmpty not).! !

!SNETTwitterFetcherTest methodsFor: 'tests' stamp: 'EBA 11/15/2014 00:04'!
testTweetsByAnyTheseHashtags
	"Test search tweets that contain any these hashtags "
	|result item|

	result := fetcher tweets: '#GODSocialNetIO OR #TestSocialNetIO'.

	self assert: (result size) > 0.

	item := result tweet: 1.

	self assert: (item isMemberOf: SNETTwitterTweet).

	self assert: (item message isEmpty not).! !

!SNETTwitterFetcherTest methodsFor: 'tests' stamp: 'EBA 11/15/2014 00:04'!
testTweetsByExactPhrase
	"Test search tweets by exact phrase."
	|result item|

	result := fetcher tweets: '"#GODSocialNetIO Teste Unitrio. Ignorar"'.

	self assert: (result size) > 0.

	item := result tweet: 1.

	self assert: (item isMemberOf: SNETTwitterTweet).

	self assert: (item message isEmpty not).! !

!SNETTwitterFetcherTest methodsFor: 'tests' stamp: 'EBA 11/15/2014 00:04'!
testTweetsByHashtag
	"Tests tweets search by hashtag."
	|result item|

	result := fetcher tweets: '#teste'.

	self assert: (result size) > 0.

	item := result tweet: 1.

	self assert: (item isMemberOf: SNETTwitterTweet).

	self assert: (item message isEmpty not).
	
	self assert: (item retweets) >= 0.
	
	self assert: (item favorited) >= 0.! !

!SNETTwitterFetcherTest methodsFor: 'tests' stamp: 'TA 11/26/2014 23:39'!
testTweetsByLanguage
	"Test search tweets from a specific language filter."
	|result item|

	fetcher := SNETTwitterFetcher new.
	fetcher connect.

	fetcher language: 'en'.
	result := fetcher tweets: 'dilma' maximum: 5.
	self assert: (result size) > 0.

	fetcher language: 'pt'.
	result := fetcher tweets: 'dilma' maximum: 5.
	self assert: (result size) > 0.

	fetcher language: 'es'.
	result := fetcher tweets: 'dilma' maximum: 5.
	self assert: (result size) > 0.

	item := result tweet: 1.

	self assert: (item isMemberOf: SNETTwitterTweet).

	self assert: (item message isEmpty not).! !

!SNETTwitterFetcherTest methodsFor: 'tests' stamp: 'EBA 11/15/2014 00:04'!
testTweetsByNoneOfTheseWords
	"Test search tweets that contain text and none of these words."
	|result item|

	result := fetcher tweets: 'dilma -acio'.

	self assert: (result size) > 0.

	item := result tweet: 1.

	self assert: (item isMemberOf: SNETTwitterTweet).

	self assert: (item message isEmpty not).! !

!SNETTwitterFetcherTest methodsFor: 'tests' stamp: 'EBA 11/15/2014 00:05'!
testTweetsFromUser
	"Tests tweet search by user."
	|result item|

	result := fetcher tweetsFrom: '#SpaceShipTwo' user: '@nasa'.

	self assert: (result size) > 0.

	item := result tweet: 1.

	self assert: (item isMemberOf: SNETTwitterTweet).

	self assert: (item message isEmpty not).! !

!SNETTwitterFetcherTest methodsFor: 'tests' stamp: 'EBA 11/15/2014 00:05'!
testTweetsFromUserMaximum
	"Tests search tweets from user with a limited number of results."
	|result item|

	result := fetcher tweetsFrom: '#SpaceShipTwo' user: '@nasa' maximum: 20.

	self assert: (result size) = 20.

	item := result tweet: 1.

	self assert: (item isMemberOf: SNETTwitterTweet).

	self assert: (item message isEmpty not).! !

!SNETTwitterFetcherTest methodsFor: 'tests' stamp: 'EBA 11/15/2014 00:05'!
testTweetsFromUserSince
	"Tests search tweets from user by date."
	|result item|

	result := fetcher tweetsFrom: '#SpaceShipTwo' user: '@nasa' since: '2014-01-01' asDate.

	self assert: (result size) > 0.

	item := result tweet: 1.

	self assert: (item isMemberOf: SNETTwitterTweet).

	self assert: (item message isEmpty not).! !

!SNETTwitterFetcherTest methodsFor: 'tests' stamp: 'EBA 11/15/2014 00:05'!
testTweetsFromUserSinceMaximum
	"Tests search tweets from user by date."
	|result item|

	result := fetcher tweetsFrom: '#SpaceShipTwo' user: '@nasa' since: '2014-01-01' asDate maximum: 20.

	self assert: (result size) = 20.

	item := result tweet: 1.

	self assert: (item isMemberOf: SNETTwitterTweet).

	self assert: (item message isEmpty not).! !

!SNETTwitterFetcherTest methodsFor: 'tests' stamp: 'EBA 11/15/2014 00:05'!
testTweetsFromUserSinceUntil
	"Tests search tweets from user by date range."
	|result item|

	result := fetcher tweetsFrom: '#SpaceShipTwo' user: '@nasa' since: '2014-01-01' asDate until: '2014-12-01' asDate.

	self assert: (result size) > 0.

	item := result tweet: 1.

	self assert: (item isMemberOf: SNETTwitterTweet).

	self assert: (item message isEmpty not).! !

!SNETTwitterFetcherTest methodsFor: 'tests' stamp: 'EBA 11/15/2014 00:05'!
testTweetsFromUserSinceUntilMaximum
	"Tests search tweets from user by date range with a maximum number of results."
	|result item|

	result := fetcher tweetsFrom: '#SpaceShipTwo' user: '@nasa' since: '2014-01-01' asDate until: '2014-12-01' asDate maximum: 20.

	self assert: (result size) = 20.

	item := result tweet: 1.

	self assert: (item isMemberOf: SNETTwitterTweet).

	self assert: (item message isEmpty not).! !

!SNETTwitterFetcherTest methodsFor: 'tests' stamp: 'EBA 11/15/2014 00:06'!
testTweetsFromUserUntil
	"Tests search tweets from user until a certain date."
	|result item|

	result := fetcher tweetsFrom: '#nasa' user: '@NASA' until: '2014-10-30' asDate.

	self assert: (result size) > 0.

	item := result tweet: 1.

	self assert: (item isMemberOf: SNETTwitterTweet).

	self assert: (item message isEmpty not).! !

!SNETTwitterFetcherTest methodsFor: 'tests' stamp: 'EBA 11/15/2014 00:06'!
testTweetsFromUserUntilMaximum
	"Tests search tweets from user until a certain date with a maximum number of results."
	|result item|

	result := fetcher tweetsFrom: '#nasa' user: '@NASA' until: '2014-10-30' asDate maximum:20.

	self assert: (result size) = 20.

	item := result tweet: 1.

	self assert: (item isMemberOf: SNETTwitterTweet).

	self assert: (item message isEmpty not).! !

!SNETTwitterFetcherTest methodsFor: 'tests' stamp: 'EBA 11/3/2014 20:54'!
testTweetsJsonTruncatedBug
	"Debug test: when the json response is too large, it gets truncated and cannot be converted.."
	|result item|

 	"This should work" 
	self shouldnt: [fetcher tweets: 'dilmabr'] raise: Error description: 'Response is being truncated.'.
! !

!SNETTwitterFetcherTest methodsFor: 'tests' stamp: 'EBA 11/15/2014 00:06'!
testTweetsMaximum
	"Tests search by text with a maximum number of results."
	|result item|

	result := fetcher tweets: '#teste' maximum: 20.

	self assert: (result size) = 20.

	item := result tweet: 1.

	self assert: (item isMemberOf: SNETTwitterTweet).

	self assert: (item message isEmpty not).
	! !

!SNETTwitterFetcherTest methodsFor: 'tests' stamp: 'EBA 11/15/2014 00:06'!
testTweetsSinceMaximum
	"Tests search by text tweeted since a specific date with a maximum number of results."
	|result item|

	result := fetcher tweets: '#teste' since: '2014-10-30' asDate  maximum: 20.

	self assert: (result size) = 20.

	item := result tweet: 1.

	self assert: (item isMemberOf: SNETTwitterTweet).

	self assert: (item message isEmpty not).
	
	self assert: (item retweets) >= 0.
	
	self assert: (item favorited) >= 0.! !

!SNETTwitterFetcherTest methodsFor: 'tests' stamp: 'EBA 11/15/2014 00:06'!
testTweetsSinceUntilMaximum
	"Tests search by text until a certain date, with a max number of results."
	|result item|

	result := fetcher tweets: 'geraldo alckmin foi' since: '2014-10-01' asDate until: '2014-12-01' asDate maximum: 20.

	self assert: (result size) = 20.

	item := result tweet: 1.

	self assert: (item isMemberOf: SNETTwitterTweet).

	self assert: (item message isEmpty not).
	
	! !

!SNETTwitterFetcherTest methodsFor: 'tests' stamp: 'EBA 11/15/2014 00:07'!
testTweetsUntil
	"Tests search by text or hashtag until a certain date."
	|result item|

	result := fetcher tweets: '#teste' until: '2014-10-01' asDate.

	item := result tweet: 1.

	self assert: (item isMemberOf: SNETTwitterTweet).

	self assert: (item message isEmpty not).! !

!SNETTwitterFetcherTest methodsFor: 'tests' stamp: 'EBA 11/15/2014 00:07'!
testTweetsUntilMaximum
	"Tests search by text."
	|result item|

	result := fetcher tweets: '#teste' until: '2014-01-01' asDate maximum: 20.

	self assert: (result size) = 20.

	item := result tweet: 1.

	self assert: (item isMemberOf: SNETTwitterTweet).

	self assert: (item message isEmpty not).! !
